/*
 * Copyright (c) 1994 The Regents of the University of California.
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice and the following
 * two paragraphs appear in all copies of this software.
 *
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA NOR BOSTON UNIVERSITY
 * BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * THE UNIVERSITY OF CALIFORNIA AND BOSTON UNIVERSITY
 * SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 */
/********************************************************************
*                      au2mpeg.c  by Jim Boucher
*
*       This script uses the sox utility and the ISO musicin
*executables to generate a minimal bitrate mpeg audio file
*from a SPARC .au file.  The SPARC .AU files are all
*single channel 8KHz ULaw formatted with a 24 byte header.
*The output mpeg audio files are single channel, 32Kbps,
*at a sample frequency of 32000 Hz in Layer II format. 
********************************************************************/

#include <stdio.h>

usage (p)
char *p;

{
    fprintf (stderr, "Usage: %s infilename outfilename ", p);
    exit (1);
}

main (argc, argv)
int argc;
char **argv;

{
    char *infilename;       /* input filename  */
    char *outfilename;      /* output filename */
    
    char command[256];      /* command line buffer */
    
    if (argc != 3) usage(argv[0]); /* to read input command and interpret */
    infilename = argv[1];
    outfilename  = argv[2];
    
/* Convert SPARC .AU file to raw 16 bit signed PCM samples */
	sprintf(command, "/home/guest/jboucher/bin/sox  \
		-t .au -r 8000 -c 1 -U -b %s  \
		-t .raw -r 8000 -c 1 -s -w /tmp/foobar copy"
		,infilename); 
	
      printf("executing system command 1\n"); 
	system(command);

/* Change the sampling rate from 8KHz to 32 KHz */
	sprintf(command, "/home/guest/jboucher/bin/sox \
		-t .raw -r 8000 -c 1 -s -w /tmp/foobar -t .raw -r 32000 -c 1 -s -w /tmp/foobar2 rate"); 
	
      printf("executing system command 2\n"); 
	system(command);

/* Encode raw PCM into mpeg audio layer II format */
 sprintf(command, "/home/guest/jboucher/audio_encode/mpegaudio/musicin /tmp/foobar2 %s -l 2 -m m -p 2 -s 32 -b 32 -d n",outfilename); 
	
      printf("executing system command 3\n"); 
	system(command);

/* clean up */
  printf("removing temporary files \n"); 
    sprintf(command, "/bin/rm  /tmp/foobar");
    system(command);
    
    sprintf(command, "/bin/rm  /tmp/foobar2");
    system(command);

    
}



