/*
 * @(#) crc.c 1.2, last edit: 1/28/94 17:47:50
 * @(#) (C) 1993/94 Tobias Bading (bading@cs.tu-berlin.de)
 * @(#) Berlin University of Technology
 */

#include <iostream.h>
#include <stdlib.h>
#include "crc.h"


// generator polinomial:
const unsigned short Crc16::polynomial = 0x8005;


void Crc16::add_bits (unsigned bitstring, unsigned length)
{
#ifdef DEBUG
  if (!length)
  {
    cerr << "Length of bitstring has to be > 0 in Crc16::add_bits()!\n";
    exit (1);
  }
#endif
  unsigned bitmask = 1 << (length - 1);
  do
    if (!(crc & 0x8000) ^ !(bitstring & bitmask))
    {
      crc <<= 1;
      crc ^= polynomial;
    }
    else
      crc <<= 1;
  while (bitmask >>= 1);
}
