/*
 * @(#) ibitstream.h 1.2, last edit: 1/28/94 17:47:47
 * @(#) (C) 1993/94 Tobias Bading (bading@cs.tu-berlin.de)
 * @(#) Berlin University of Technology
 */

#ifndef BITSTREAM_H
#define BITSTREAM_H

#include "all.h"


const unsigned bufferintsize = 433;
	// max. 1730 bytes per frame: 144 * 384kbit/s / 32000 Hz + 2 Bytes CRC


// Class to extract bitstrings from files:
class Ibitstream
{
  int		fd;
  unsigned	buffer[bufferintsize];
  unsigned	framesize;		// number of valid bytes in buffer
  unsigned	*wordpointer;		// position of next unsigned int for get_bits()
  unsigned	bitindex;		// number (0-31, from MSB to LSB) of next bit for get_bits()

public:
		Ibitstream (int filedescriptor);
		Ibitstream (const char *filename);
		~Ibitstream (void);
  int		filedescriptor (void) { return fd; };

  bool		get_header (unsigned *);
		// get next 32 bits from bitstream in an unsigned int,
		// returned value False => end of stream
  bool		read_frame (unsigned bytesize);
		// fill buffer with data from bitstream, returned value False => end of stream
  unsigned	get_bits (unsigned number_of_bits);
		// read bits (1 <= number_of_bits <= 16) from buffer into the lower
		// bits of an unsigned int. The LSB contains the latest read bit of the stream.
};

#endif
