/*
 * @(#) obuffer.h 1.3, last edit: 2/2/94 17:22:27
 * @(#) (C) 1993/94 Tobias Bading (bading@cs.tu-berlin.de)
 * @(#) Berlin University of Technology
 */

#ifndef OBUFFER_H
#define OBUFFER_H

#include <iostream.h>
#include <unistd.h>
#include <stdlib.h>
#include "all.h"
#include "header.h"
#include "audio_includes.h"


static const unsigned OBUFFERSIZE = 2 * 1152;	// max. 2 * 1152 samples per frame
static const unsigned MAXCHANNELS = 2;		// max. number of channels


class Obuffer
{
public:
  virtual     ~Obuffer (void) {}
  virtual void append (unsigned channel, short value) = 0;
  virtual void write_buffer (int fd) = 0;
};


class ShortObuffer : public Obuffer
{
private:
  short buffer[OBUFFERSIZE];
  short *bufferp[MAXCHANNELS];
  unsigned channels;

public:
	ShortObuffer (unsigned number_of_channels);
       ~ShortObuffer (void) {}
  void	append (unsigned channel, short value);
  void	write_buffer (int fd);
};


#ifdef Indigo
// a class for direct sound output on SGI machines:
class IndigoObuffer : public Obuffer
{
private:
  short buffer[OBUFFERSIZE];
  short *bufferp[MAXCHANNELS];
  unsigned channels;
  ALport port;

public:
	IndigoObuffer (unsigned number_of_channels, Header *);
       ~IndigoObuffer (void);
  void	append (unsigned channel, short value);
  void	write_buffer (int dummy);
};
#endif	// Indigo


#ifdef SPARC
// a class for direct sound output on SPARC 10 machines: (dbri device)
class SparcObuffer : public Obuffer
{
private:
  short buffer[OBUFFERSIZE];
  short *bufferp[MAXCHANNELS];
  unsigned channels;
  static int audio_fd;

  static int open_audio_device (void);
#ifdef Solaris
  static void get_device_type (int fd, audio_device *);
#else
  static int get_device_type (int fd);
#endif

public:
	SparcObuffer (unsigned number_of_channels, Header *,
 		      bool use_speaker, bool use_headphones, bool use_line_out);
       ~SparcObuffer (void);
  void	append (unsigned channel, short value);
  void	write_buffer (int dummy);

  static bool class_suitable (void);
	// returnvalue == False: no 16-bit output possible (class unsuitable)
};
#endif	// SPARC

#endif
