/*
 * @(#) subband.h 1.2, last edit: 1/28/94 17:47:35
 * @(#) (C) 1993/94 Tobias Bading (bading@cs.tu-berlin.de)
 * @(#) Berlin University of Technology
 */

#ifndef SUBBAND_H
#define SUBBAND_H

#include "all.h"
#include "ibitstream.h"
#include "header.h"
#include "synthesis_filter.h"
#include "crc.h"

enum e_channels { both, left, right };

class Subband
{
public:
  virtual void read_allocation (Ibitstream *, Header *, Crc16 *) = 0;
  virtual void read_scalefactor (Ibitstream *, Header *) = 0;
  virtual bool read_sampledata (Ibitstream *) = 0;
  virtual bool put_next_sample (e_channels, SynthesisFilter *, SynthesisFilter *) = 0;
};

#endif
