/*
 * @(#) subband_layer_1.h 1.2, last edit: 1/28/94 17:47:41
 * @(#) (C) 1993/94 Tobias Bading (bading@cs.tu-berlin.de)
 * @(#) Berlin University of Technology
 */

#ifndef SUBBAND_LAYER_1_H
#define SUBBAND_LAYER_1_H

#include "all.h"
#include "subband.h"
#include "crc.h"


class SubbandLayer1 : public Subband
{
protected:
  unsigned subbandnumber;
  unsigned samplenumber;
  unsigned allocation;
  unsigned scalefactor;
  unsigned samplelength;
  real	   sample;
  real	   factor, offset;

public:
       SubbandLayer1 (unsigned subbandnumber);
  void read_allocation (Ibitstream *, Header *, Crc16 *);
  void read_scalefactor (Ibitstream *, Header *);
  bool read_sampledata (Ibitstream *);
  bool put_next_sample (e_channels, SynthesisFilter *, SynthesisFilter *);
};


class SubbandLayer1IntensityStereo : public SubbandLayer1
{
protected:
  unsigned channel2_scalefactor;

public:
       SubbandLayer1IntensityStereo (unsigned subbandnumber);
  void read_allocation (Ibitstream *stream, Header *header, Crc16 *crc)
  {
    SubbandLayer1::read_allocation (stream, header, crc);
  }
  void read_scalefactor (Ibitstream *, Header *);
  bool read_sampledata (Ibitstream *stream)
  {
    return SubbandLayer1::read_sampledata (stream);
  }
  bool put_next_sample (e_channels, SynthesisFilter *, SynthesisFilter *);
};


class SubbandLayer1Stereo : public SubbandLayer1
{
protected:
  unsigned channel2_allocation;
  unsigned channel2_scalefactor;
  unsigned channel2_samplelength;
  real	   channel2_sample;
  real	   channel2_factor, channel2_offset;

public:
       SubbandLayer1Stereo (unsigned subbandnumber);
  void read_allocation (Ibitstream *, Header *, Crc16 *);
  void read_scalefactor (Ibitstream *, Header *);
  bool read_sampledata (Ibitstream *);
  bool put_next_sample (e_channels, SynthesisFilter *, SynthesisFilter *);
};

#endif
