/*
 * @(#) subband_layer_2.h 1.2, last edit: 1/28/94 17:47:43
 * @(#) (C) 1993/94 Tobias Bading (bading@cs.tu-berlin.de)
 * @(#) Berlin University of Technology
 */

#ifndef SUBBAND_LAYER_2_H
#define SUBBAND_LAYER_2_H

#include <stdio.h>
#include "all.h"
#include "subband.h"
#include "header.h"
#include "crc.h"


class SubbandLayer2 : public Subband
{
protected:
  unsigned subbandnumber;

  unsigned allocation;
  unsigned scfsi;
  unsigned scalefactor1, scalefactor2, scalefactor3;
  bool	   grouping;
  unsigned codelength;
  unsigned quantizationsteps;
  real	   factor;

  unsigned groupnumber;
  unsigned samplenumber;
  real	   samples[3];
  real	   c, d;

  unsigned get_allocationlength (Header *);
  unsigned prepare_sample_reading (Header *, unsigned, bool *, unsigned *, real *,
				   unsigned *, real *, real *);

public:
		SubbandLayer2 (unsigned subbandnumber);
  void		read_allocation (Ibitstream *, Header *, Crc16 *);
  virtual void	read_scalefactor_selection (Ibitstream *, Crc16 *);
  void		read_scalefactor (Ibitstream *, Header *);
  bool		read_sampledata (Ibitstream *);
  bool		put_next_sample (e_channels, SynthesisFilter *, SynthesisFilter * = NULL);
};


class SubbandLayer2IntensityStereo : public SubbandLayer2
{
protected:
  unsigned channel2_scfsi;
  unsigned channel2_scalefactor1, channel2_scalefactor2, channel2_scalefactor3;

public:
       SubbandLayer2IntensityStereo (unsigned subbandnumber);
  void read_allocation (Ibitstream *stream, Header *header, Crc16 *crc)
  {
    SubbandLayer2::read_allocation (stream, header, crc);
  }
  void read_scalefactor_selection (Ibitstream *, Crc16 *);
  void read_scalefactor (Ibitstream *, Header *);
  bool read_sampledata (Ibitstream *stream)
  {
    return SubbandLayer2::read_sampledata (stream);
  }
  bool put_next_sample (e_channels, SynthesisFilter *, SynthesisFilter *);
};


class SubbandLayer2Stereo : public SubbandLayer2
{
protected:
  unsigned channel2_allocation;
  unsigned channel2_scfsi;
  unsigned channel2_scalefactor1, channel2_scalefactor2, channel2_scalefactor3;
  bool	   channel2_grouping;
  unsigned channel2_codelength;
  unsigned channel2_quantizationsteps;
  real	   channel2_factor;
  real	   channel2_samples[3];
  real	   channel2_c, channel2_d;

public:
       SubbandLayer2Stereo (unsigned subbandnumber);
  void read_allocation (Ibitstream *, Header *, Crc16 *);
  void read_scalefactor_selection (Ibitstream *, Crc16 *);
  void read_scalefactor (Ibitstream *, Header *);
  bool read_sampledata (Ibitstream *);
  bool put_next_sample (e_channels, SynthesisFilter *, SynthesisFilter *);
};

#endif
