/*
 * @(#) synthesis_filter.h 1.2, last edit: 2/3/94 17:18:45
 * @(#) (C) 1993/94 Tobias Bading (bading@cs.tu-berlin.de)
 * @(#) Berlin University of Technology
 */

#ifndef SYNTHESIS_FILTER_H
#define SYNTHESIS_FILTER_H

#include <iostream.h>
#include "all.h"
#include "obuffer.h"


class SynthesisFilter
{
  static const real d[512];
  static const real n[32][31];
  real v1[512], v2[512];
  real *actual_v;			// v1 or v2
  unsigned actual_write_pos;		// 0-15

  real	   samples[32];			// max. 32 new subband samples
  unsigned subbandnumbers[32];		// subbandnumbers of new samples
  unsigned number_of_samples;		// number of elements in samples[] and subbandnumbers[]

  unsigned channel;
  real	   scalefactor;
  unsigned range_violations;
  real	   max_violation;
  unsigned written_samples;

  void initialize_new_v (real *);
  void compute_new_v (real *);
  void check_new_v (real *);
  void insert_new_v (real *);
  void compute_pcm_samples (Obuffer *);

public:
	SynthesisFilter (unsigned channelnumber, real scalefactor = 32768.0);
	// the scalefactor scales the calculated float pcm samples to short
	// (raw pcm samples are in [-1.0, 1.0], if no violations occur

  void	input_sample (real sample, unsigned subbandnumber)
  {
    samples[number_of_samples] = sample;
    subbandnumbers[number_of_samples++] = subbandnumber;
  };
  void	calculate_pcm_samples (Obuffer *);

  unsigned violations (void) { return range_violations; }
  real	   hardest_violation (void) { return max_violation; }
  unsigned recommended_scalefactor (void) { return (unsigned)(32768.0 / max_violation); }
  real	   seconds_played (unsigned frequency)
  {
    return (real)written_samples / (real)frequency;
  }
};

#endif
